/*
 * VariablesBarSymbol.h
 *
 *  Created on: Apr 10, 2013
 *      Author: Jan Travnicek
 */

#include "VariablesBarSymbol.h"
#include <sax/FromXMLParserHelper.h>
#include "Symbol.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include "UniqueSymbol.h"

namespace alphabet {

VariablesBarSymbol::VariablesBarSymbol ( ) {
}

SymbolBase * VariablesBarSymbol::clone ( ) const {
	return new VariablesBarSymbol ( * this );
}

SymbolBase * VariablesBarSymbol::plunder ( ) && {
	return new VariablesBarSymbol ( std::move ( * this ) );
}

int VariablesBarSymbol::compare ( const VariablesBarSymbol & ) const {
	return 0;
}

void VariablesBarSymbol::operator >>( std::ostream & out ) const {
	out << "(Variables bar symbol)";
}

VariablesBarSymbol::operator std::string ( ) const {
	return VariablesBarSymbol::instance < std::string > ( );
}

VariablesBarSymbol VariablesBarSymbol::parse ( ext::deque < sax::Token >::iterator & input ) {
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::START_ELEMENT, VariablesBarSymbol::getXmlTagName() );
	sax::FromXMLParserHelper::popToken ( input, sax::Token::TokenType::END_ELEMENT, VariablesBarSymbol::getXmlTagName() );

	return VariablesBarSymbol ( );
}

void VariablesBarSymbol::compose ( ext::deque < sax::Token > & out ) const {
	out.emplace_back ( VariablesBarSymbol::getXmlTagName(), sax::Token::TokenType::START_ELEMENT );
	out.emplace_back ( VariablesBarSymbol::getXmlTagName(), sax::Token::TokenType::END_ELEMENT );
}

SymbolBase * VariablesBarSymbol::inc ( ) && {
	return new UniqueSymbol ( Symbol ( std::move ( * this ) ), primitive::Integer ( 0 ) );
}

} /* namespace alphabet */

namespace alib {

auto variablesBarSymbolType = registration::TypeRegister < alphabet::Symbol, alphabet::VariablesBarSymbol > ();
auto variablesBarSymbolType2 = registration::TypeRegister < alib::Object, alphabet::VariablesBarSymbol > ();

} /* namespace alib */
