/*
 * PrefixRankedPattern.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrefixRankedPattern.h"
#include "../Tree.h"
#include "../RankedTreeWrapper.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto prefixRankedPatternType = registration::TypeRegister < tree::Tree, tree::PrefixRankedPattern < > > ( );
auto prefixRankedPatternType2 = registration::TypeRegister < tree::RankedTreeWrapper, tree::PrefixRankedPattern < > > ( );
auto prefixRankedPatternType3 = registration::TypeRegister < alib::Object, tree::PrefixRankedPattern < > > ( );

auto PrefixRankedPatternFromRankedPattern = registration::CastRegister < tree::PrefixRankedPattern < >, tree::RankedPattern < > > ( );
auto PrefixRankedPatternFromPrefixRankedTree = registration::CastRegister < tree::PrefixRankedPattern < >, tree::PrefixRankedTree < > > ( );

auto PrefixRankedPatternName = registration::NameRegister < tree::PrefixRankedPattern < > > ( tree::PrefixRankedPattern < >::getXmlTagName ( ) );

} /* namespace alib */
