/*
 * PrefixRankedTree.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#include "PrefixRankedTree.h"
#include "../Tree.h"
#include "../RankedTreeWrapper.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto prefixRankedTreeType = registration::TypeRegister < tree::Tree, tree::PrefixRankedTree < > > ( );
auto prefixRankedTreeType2 = registration::TypeRegister < tree::RankedTreeWrapper, tree::PrefixRankedTree < > > ( );
auto prefixRankedTreeType3 = registration::TypeRegister < alib::Object, tree::PrefixRankedTree < > > ( );

auto PrefixRankedTreeFromRankedTree = registration::CastRegister < tree::PrefixRankedTree < > , tree::RankedTree < > > ( );

auto PrefixRankedTreeName = registration::NameRegister < tree::PrefixRankedTree < > > ( tree::PrefixRankedTree < >::getXmlTagName ( ) );

} /* namespace alib */
